/*
 *
 * 		Copyright(R) 2002 Applied Data Systems, Inc.
 *
 * 		Digital IO via CPLD on Bitsy Plus
 *
 *		This file should be matched to EIO driver
 *
 * 		Revision History:
 * 			Jun-12-02 WH
 * 				Add IOControl functions to access all ports one.
 */

#ifndef	_EIO_CTL_
#define	_EIO_CTL_

//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
//

#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
)

//
// Define the method codes for how buffers are passed for I/O and FS controls
//

#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3

//
// Define the access check value for any access
//
//
// The FILE_READ_ACCESS and FILE_WRITE_ACCESS constants are also defined in
// ntioapi.h as FILE_READ_DATA and FILE_WRITE_DATA. The values for these
// constants *MUST* always be in sync.
//

#define FILE_ANY_ACCESS                 0
#define FILE_READ_ACCESS          ( 0x0001 )    // file & pipe
#define FILE_WRITE_ACCESS         ( 0x0002 )    // file & pipe


#define FILE_DEVICE_EIO		0x0000F012  // range 0-32767 is for Microsoft

#define IOCTL_EIO_CONFIG_PORTS \
		CTL_CODE(FILE_DEVICE_EIO, 3, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_EIO_READ_CONFIG \
		CTL_CODE(FILE_DEVICE_EIO, 4, METHOD_BUFFERED, FILE_ANY_ACCESS)

#endif